﻿function XCharacterManager()
{
    this.LS_KEY_PREFIX = 'CH-';

    this.getKeys = function()
    {
        var keys = [];

        for (var i = 0, len = localStorage.length; i < len; ++i)
        {
            var key = localStorage.key(i);

            if (key.startsWith(this.LS_KEY_PREFIX))
            {
                keys.push(key);
            }
        }

        return keys;
    };

    this.getNextId = function()
    {
        var keys = this.getKeys();
        console.log(keys);
        var maxIndex = 1;

        _.each(keys, function(key)
        {
            var p = key.split('.');
            var index = parseInt(p[1]);
            if (index > maxIndex)
            {
                maxIndex = index;
            }
        });

        maxIndex++;

        return this.LS_KEY_PREFIX + maxIndex.toString();
    };

    this.save = function(c)
    {
        c.id = this.getNextId();

        localStorage.setItem(c.id, JSON.stringify(c));
    };

    this.load = function(id)
    {
        var json = localStorage.getItem(id);

        if (json == null)
        {
            console.log("Invalid character ID: " + id);
            return null;
        }

        return JSON.parse(json);
    };
}